"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var generateBlog = require('./generate-blog-index');

var BlogIndexPlugin =
/*#__PURE__*/
function () {
  function BlogIndexPlugin(options) {
    _classCallCheck(this, BlogIndexPlugin);

    this.options = options;
  }

  _createClass(BlogIndexPlugin, [{
    key: "getChangedFiles",
    value: function getChangedFiles(compiler) {
      var watchFileSystem = compiler.watchFileSystem;
      var watcher = watchFileSystem.watcher || watchFileSystem.wfs.watcher;
      return Object.keys(watcher.mtimes);
    }
  }, {
    key: "apply",
    value: function apply(compiler) {
      var _this = this;

      // Set up blog index at start
      compiler.hooks.environment.tap('MyPlugin', function () {
        generateBlog(_this.options);
      }); // Re generate blog index when MDX files change

      compiler.hooks.watchRun.tap('MyPlugin', function () {
        var changedFile = _this.getChangedFiles(compiler);

        if (changedFile.find(function (file) {
          return file.includes('.mdx');
        })) {
          generateBlog(_this.options);
        }
      });
    }
  }]);

  return BlogIndexPlugin;
}();

module.exports = function () {
  var pluginOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function () {
    var nextConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return Object.assign({}, nextConfig, {
      webpack: function webpack(config, options) {
        if (!options.defaultLoaders) {
          throw new Error('This plugin is not compatible with Next.js versions below 5.0.0 https://err.sh/next-plugins/upgrade');
        }

        config.plugins.push(new BlogIndexPlugin(pluginOptions));

        if (typeof nextConfig.webpack === 'function') {
          return nextConfig.webpack(config, options);
        }

        return config;
      }
    });
  };
};